Overview

DataArmour is a local, intra and internet backup system. It allows you to backup anything, to anywhere, automatically (assuming, of course, that you have access to do so).

DataArmour allows selection of files to be backed up using a rule based system, giving flexibility yet retaining ease of use. Also included is comprehensive logging, support for ZIP (or other types of removable drive) drives, compression, adjustable priorities for both main application and its threads, ability to run from some other scheduler, and multi-threading.

You can specify what things to backup, as well as what you want to include/exclude very easily. DatArmour then runs in the background and takes care of everything for you.

DataArmour includes the following features:

  • Compatible with Windows 95 and above, Windows NT4.0 and above
  • Backup local and LAN directories to a named location. This location can either be local, on a LAN (using UNC names if you preffer) or an FTP server
  • Backup multiple source files, from multiple directories and retain the relevant directory/path information
  • Include and exclude files from the backup operation using powerfull and flexible rules.
  • Optionally compress the backup to a ZIP file.
  • Configurable compression levels for each ZIP file.
  • Ability to schedule the backup opterations
  • Preview the effect of a backup, without performing the backup
  • Ability to monitor specific directories for changes, and then run the backup (this can also be delayed)
  • Run many backup operations simulateously (this is configurable)
  • Run individual items at their own priorities, allowing more important items to complete first.
  • After completing the backup, list (and optionally remove) any files that have been deleted from the source.
  • Works with virtually any FTP server
  • Full logging of backup operation
  • Encrypt registry settings
  • Many backup options

Registered users receive:

  • Free technical support (via email)
  • Earliest notification of upgrades and new releases
  • Discounts on upgrades
  • Ability to participate in beta-tests of upcoming releases


Performing a backup

Getting started

This section outlines the basic operations required to create and run a backup using DataArmour. The other topics under this section document all of the options available.

The other topics are:

  • Scheduling
  • General options
  • Backup types
  • Rule editing
  • FTP Options
  • The FTP format editor

DataArmour perfoms a backup using a number of 'backup items'. Each item specifies some source files and a destination folder. You can configure any number of backup items (limited only by memory and processing power).

Structure your backups any way you like, but normally you would create one backup item for every type of information. For example: You might have five items, named Source code, Documents, Web pages, Misc spreadsheets and Financial. These items would be configured to backup important documents related to the name of the item. (e.g: Web pages would backup all .HTML files and scripts, perhaps graphics as well)

To implement the above scheme, you would create five items with the names above, then create appropriate rules for those items.

How to use the basic features of DataArmour

Even for novice users, DataArmour should be easy to use. The following sections summarise the basic operations:

  • Adding an item:
    Either click on the Insert item button in the toolbar, or choose the Insert item... option on the Edit menu. A new window will appear, asking you for the items name, destination directory and backup type (there are additional tabs and options, these are explained in the other topics of this section).

    The item name should be something meaningful (e.g: Web pages). It must be unique among all other items.
    The destination directory is the place where DataArmour will copy the files to.
    The copy type is either Direct; where files are simply copied from the source to the destination, or ZIP; where files are compressed into one ZIP file.

    Note:
    It is important that you specify a different path for each Direct copy item. Otherwise all files will be placed into the same directory.     e.g: If I have two direct copy items, Web Pages and Source Code, then one might go to E:\BACKUP\WEBPAGES and the other to E:\BACKUP\SOURCECODE. But it is a mistake to configure both to go to E:\BACKUP.
  • Editing an item:
    You can edit any item by either double clicking it's name in the list window, choosing Edit item... from the Edit menu or clicking on the Edit selected item button in the toolbar.

    The item editor dialog will appear with the item's details. Click OK to confirm any changes, or Cancel to discard.     Note: If you make changes to the rules of an item while that item is running, you will not be able to confirm the changes until that item has completed.
  • Deleting an item:
    Either choose Delete item from the Edit menu, or click on the Delete item button in the toolbar. You will be prompted to remove the item. If you click OK, the item is removed. The action cannot be undone (unless of course, you have backed up your configuration files!)

In general, to perform a backup:

  1. Create an item
    • Name the item and set its schedule and options
    • Add rules. One for each directory you want to backup. Set the constraints on those rules.
    • Select the backup type, either Direct copy or ZIP copy
  2. Done!. If you did not change the default next execution time, your backup should be running. If you did change the next execution time and you want to run the backup straight away, click on the 'Run item now' button in the toolbar.
  3. If you see a cross beside the item in the list, this means that the item has not been configured to run on this day. Change this using the scheduler options

The backup item will now run according to the schedule you setup on the Schedule tab of the item's option editor. You can force the item to run by selecting it, then clicking the Run item now button on the toolbar (or choosing Run item from the Main menu. View the other topics under this heading for more information, they contain details explanations of all DataArmour functions and operations.

Note: You can perform the edit and delete opterations on multuple items at once by selecting items using either the shift key (to select a list of items) or the ctrl key (to select more than one item at a time).

List views

DataArmour provides a list view for the items, similar to the windows explorer. You can change the view to any one of Large icons, Small icons, List or details. To change the list view mode, use the toolbar buttons.

Window position and style

The size and position of the main window (along with the list view style) is saved when you exit DataArmour. When you restart DataArmour, the window and its style is restored.


Scheduling

Options

The following scheduling options are available:

Interval

This is only enabled if there is at least one rule for the item that does not have it's 'on file change' option set (see the help section on rules for more information). If enabled, it specifies the time between backups. e.g: If set to 1, then DataArmour will execute this item every hour. If set to 12, then the item will be run every 12 hours.

Thread priority

Specifies the priority of this item (when it is running), in relation to DataArmour, not to the operating system (Windows). The distinction is important! If set to idle (the lowest priority) all other running items will have priority over this one. Items at the same priority run as you would expect, they share the available resources.
Note: When an item is scanning the disk for files (this happens during the initial phase of the backup), it consumes a fair amount of resource. If you have multiple items all scanning the disk - then this can effect system performance.

Schedule

Allows you to specify when it is OK for DataArmour to backup the directories specified by this item. Click the checkboxes to indicate the days. If no checkboxes are clicked, then the item will never be run. Items that cannot be run on the current day are marked with a cross beside their names in the list view.

The next execution time specifies when the item is next going to run. You can modify this by clickin on the combo box arrow (for the date) or the up/down buttons (for the time). You can also click in the edit boxes and type in a new date or time.


Setting backup options

General backup options

Backup options

Directory Tree Options specifies what directory structure information will be saved at the destination location for the backup. These options are only available when the backup type is of copy.

Replicate empty directories | If unchecked, then empty directories on the source are not created on the destination. If you have a source directory structure that is important, with some directories not containing any files - this item should be checked. If you are unsure, then check this item.
Delete files no longer on source | The processing associated with this option happens at the end of the backup. If checked, any files that exist at the destination but do not exist at the source will be removed from the destination. This is usefull if the contents or structure of the location you are backing up from changes frequently. If this is the case, then this option will ensure that the destination is structured as close as possible to the source.
Prompt if volume not loaded | If this is enabled, a check will be performed before the backup starts to ensure that the right disk/catridge is loaded on the destination device. This option make no sense whatsoever for non removable destinations (like local fixed disk drives). It should be used if you are backing up to a ZIP (tm) or LS-120 drive, and you want to make sure that the right disk is in the unit before the backup starts.
Keep the last 'n' backup(s) If enabled, before the backup starts, existing backups will be reshuffled. For example, if you have entered 4 in the edit box, and the backup starts - the following will happen:
  • backup 4 is deleted
  • backup 3 is renamed to backup 4
  • backup 2 is renamed to backup 3
  • backup 1 is renamed to backup 2
  • a new backup file (either ZIP or a directory) is created.

There is no real limit to this process other than disk space. DataArmour sets the limit to 400, although if you use this at all, you will most likely set it to some value between 2 and 10.

Include in activity report

List of files scanned | If enabled, the complete list of files that were scanned from the source directories will be included in the log. Note: The scanning process is intelligent - and automatically excludes those files that appear to be the same on the source and destination); so do not expect a complete file list to be dumped to the log every time a backup is run.
List of files actually backed up | This option is only of real use when performing a ZIP backup. While DataArmour tries to be intelligent regarding the files that is scans from the source directories, it is possible that the ZIP processor will differ. If checked, a listing of the files that were actually added or updated to the ZIP file will be listed here (note: Files that are removed from the zip file are recorded in a seperate list).
Files that have been deleted from the source | If checked, a list of the files that would be removed from the destination (because the files no longer exist on the source) is added to the log. The files are only removed from the source if the delete files no longer on source option is also enabled.
All FTP activity | This option is only available if the backup item's destination is an FTP server. If enabled, all FTP commands and their responses (appart from the password command) are logged. This log can be quite lengthy.

Wait for inactivity before starting the backup

This option is only available if at least one of the rules specified by the item has it's on file change option set. If enabled, and something in the specified directorie(s) changes ((file name, file size, addition or removal of directory or file, etc) then the backup is started. Often, it is not desirable for the backup to start straight away. This option adds a fixed amount (specified in the edit box) to the next execution time, so that the backup starts sometime in the future.

e.g: If this option enabled and set to 5, and you add a file to source directory that is being monitored, the backup for that source directory will run in five minutes time.

If you continually make changes ot the source directory (less than every 5 minutes) the backup will never run. In these cases, do not set the on file change option on those directories. Instead, use standard scheduling.

Directory Tree Options
These options are available when the Backup method is Copy files to destination. These options effect how DataArmour stores the directory structure of the source files on the destination drive.

directorytreeoptions.gif (1806 bytes)

Entire Structure will force DataArmour to backup the source file, with its directory structure, while Some structure, grouped by UNC will only back up what is necessary to keep the source file name unique on the destination.

Open File Options
 optionsfileopen.gif (2248 bytes)

Use this option to configure how DataArmour handles files which other applications could be writing to (This is known as "shared write access"). Note: It is acceptable for other applications to be reading files, just not writing to the files. If you do not wish DataArmour to check for open files, then you run the risk of backing up a corrupt or zero length file, or worse backing up a file that is currently being written to.

If you wish DataArmour to check for open files, you have two options:
Skip files - This is the default option and forces DataArmour to skip any open files. Skipped files are noted in the log, if any are skipped then the backup item completes with the status of warning. This is represented by a yellow exclamation mark (!) in the list and a yellow stem of the DataArmour system tray icon.
Wait for file - If DataArmour detects that the file is open for shared write, rather than simply skipping the file, it will wait for the specified period for the file to become available. It performs a periodic check for this availability. If the time is exceeded the file is skipped and this is noted in the log as above. The maximum wait is 120 seconds. This option is not available when the backup type is zip.


Direct copy / ZIP Copy

Backup types

Direct copy

In this mode, DataArmour will copy the files from the source location(s) without any compression, directly to the destination location. The Directory Tree option will effect how the backup is performed. ZIP options are not available for direct copy backups.

ZIP Copy

Files from the source location(s) will be added, or updated, to a ZIP file at the destination location. The ZIP file will have the same name as the backup item, but with the extension .zip. Directory Options and Replicate empty directories options are not available for ZIP copy backups.

ZIP files are readable with any ZIP viewer/extractor that adheres to the PKZIP 2.00 format.

ZIP Options

zipoptions.gif (8235 bytes)

  • ZIP Compression level - specifies the amount of compression applied to the ZIP file. Lower values increase the speed of the process, but decrease the effectiveness of the compression. Higher values mean that the ZIP file takes less space on the destination, but processing takes longer. A typical value is "Great"
  • Use full pathnames in ZIP file - If enabled, the complete path to the file is stored in the ZIP file. If disable, only the filename is stored in the ZIP file. Enabling this option, and backing up from two distinct directories is a invalid combination; this is because you loose the subdirectory information - thus compromising the accuracy of the backup.
  • Log all ZIP activity - All messages (rather than just the basic, normal messages) are put into the activity log. This is especially useful if you are experiencing problems during the ZIP process. Enabling this option, and examining the output in the log may help you isolate the problem.
  • Use specific folders

    When a ZIP copy starts, a backup is made of the current, most up to date version of the ZIPped backup file. This is done so that if anything goes wrong; your original backup file is not corrupted.
    Normally, this temporary "in-progress" file, is created in Destination Directory of the backup. This is not always desirable. For example: If you are backing up to a floppy device, you will not want the temporary file to be copied from the floppy to the floppy. This would be a very slow process.

    If you find yourself in this situation, or simply want to distribute the disk-space-processing requirements, you can specify a directory that should be used for the temporary in-progress file. The button on the right allows you to browse for the folder.


External Options

This offers you the flexibility to execute programs or batch files imediately before or after a backup item. The following are some examples of how you could use this feature:

  • To make a RAS connection to an FTP server, before backing up files to the site.
  • To shut down NT services before backing up files that would normally be kept open.

external options tab.jpg (27237 bytes)

Before item begins:

In the command field you should enter the name of the program or batch file that you wish to execute before the backup item is run. Any valid DOS or Windows Application can be executed, or you may execute a batch file. If you wish to execute a batch file, you must execute command.com (or command.exe) before the name of the batch file.

If the application or batch file fails to execute correctly, you can instruct DataArmour to continue with the backup item regardless. By default, DataArmour will not continue with the backup if the applicaiton or batch file fails. DataArmour uses application error codes to test for failure.

After item completes:

After the backup item has run, you can once again execute a program or batch file in similar conditions to the Before item begins option. By default DataArmour will execute the command even if the backup item fails.


Rule editor

Options

In short, a rule is a directory. It also contains information on what things in that directory should be included or excluded from the backup. A single backup item can have virtually any number of rules (limited by memory and processing power). DataArmour uses the rules to decide which files should be included in a backup.

Before learning about the rule editor in detail, some information about the options:

Include subdirectories | Indicates that the sub-folders and their files (and their sub-folders ... etc) are to be included in the backup.
On file change | Specifies that this directory should be monitored for changes. Change include: Renaming, editing, deleting or adding a file. Renaming, adding or removing a directory.
Source folder | The directory that this rule applies to. Naming this directory includes it in the backup.

The part of the path listed below the browse button is the common prefix for the selected rule.

Adding rules

To add a rule, click on the 'Add rule' button in the toolbar. Each rule must specify a valid location. You can either type the name of the directory or click the browse button to bring up a directory browser.

Adding constraints

This window appears below the rule options when you click on any of the constraints of a rule.

A constraint includes or excludes files from the rule. New rules include a Include if file matches wildcard '*' constraint by default.

Operation | Specifies the constraint type. Either inclusion or exclusion
If | Specifies what part of the path/filename the constrait applies to. File and path: The entire pathname, includng the name of the file and its extension. Filename: The file name and its extension only (does not include the path). Path: The pathname only (does not include filename or its extension). Extension: The filename extension only. Note: Extensions begin with a period (.) If you are going to specify an extension, it should be of the form .txt, .bat, etc. (simply remember to put period at the beginning of the extension)
Operator | The operator applies to the part of the filename specified in the if selection. Equals: The if selection must be equal to this for the constraint to be applied. Contains: The if selection must contain this for the constaint to be applied. Wildcard: The if selection must match the wilcard specified in this for the rule to be applied.
This | The text part of the constraint.

If you read the constraints in an english like manner, their purpose should be come clearer. The text representation of the constraint changes as you work with the constraint editor.

Rules are applies in order of depth. Those rules higher in the structure are applied first. The net effect of this is that with a set of rules like:

rulesexample.gif (6967 bytes)

Two other options, that cannot be seen in the above picture:

  • For rule C:\, include subdirectories is false
  • For rule C:\Windows\, include subdirectories is true

This should be intepreted as: Only *.BAT, *.SYS and *.TXT files are included from C:\. No files are included from C:\WINDOWS or any of its subdirectories. One exception is the directory C:\Windows\Recent, where all files are included.

Any set of rules can be intepreted by simply reading them in order as they appear. Rules that appear after other rules always override those preceeding rules.


FTP Options

To Preform a backup to an FTP site you must enable the Perform backup to FTP site option. This can be found on the Item Options tab.

The destination folder now specifies an directory on the FTP server (rather than a directory on the local machine, or LAN). Note: FTP directory names use forward slashes as opposed to backslashes.

A directory must be specified. Even if you specify only the root directoy (which would be '/')

General FTP Options

Server address | You must enter the host name of the FTP server. This may be entered as the host IP address, or if you have DNS support, the DNS name.
User name | This must be a valid user name for the FTP site. Note: You will probably not be able to log in as anonymous. It is unlikely that a system administrator is going to enable anonymous users write access to a site.
Password | Valid password for the above user
FTP Timeout | This is the amount of time in seconds that DataArmour will wait for responses from the FTP server before timing out. If your connection is slow, you should increase this value.

FTP Format Items

After DataArmour has retrieved a directory listing from the FTP server, it needs to examine each line and understand which parts of the line make up the attributes, size, date, time and filename.

Due to the many different FTP servers in use today, DataArmour enables you to educate it in order that is can understand different listings from different servers. Writing and understanding the format editor requires some technical knowledge. If you are unsure how to write the FTP expressions, you should contact your system administrator.

This section of the FTP options editor lists the available FTP list format expressions. From here you can add, edit or remove expressions.


FTP Format Editor

Format name | This is a unique name identifier for the format you are creating. This will be used to identify the FTP format in the Server list format field of the previous options page.
List command | This is the command that will generate a file listing on the remote FTP server. Usually, this is 'LIST'
Ignore line if ... | DataArmour can get confused if it tries to parse a line that does not adhere to the list expression. Examples are lines like 'total number of files 2317' etc. You can tell the parser to ignore lines starting with certain letters. Enter all of the letters you wish to ignore in this edit box. NOTE: DataArmour looks only at the first character of each line. So if you wanted to ignore any lines starting with any of a, r, t, u or w you would enter 'artuw' into this edit box. The comparission is case sensitive, so 'artuw' is not the same as 'ARTUW'.

Site specific options

Use File size in comparisons | Select this option if you wish DataArmour to use the file size of any existing destination file in its comparison. The comparison is used to establish if the destination file is older than the source for a backup (this saves time when performing successive backups, as not all files need to be copied to the destination)
Use Date/time in comparisons | As above, this option enables DataArmour to compare a destination file against the source by means of last modified date and time.
Supports SITE CHMOD | Typically a UNIX based FTP command which changes the permissions on a file. Not all servers support this command. If your server does, DataArmour will be able to copy the file permissions from your system to the files stored on the FTP server (e.g.: Read only files of your system will be marked as read only on the FTP server)
Skip line if it fails parsing | Usefull if your FTP server returns banners before the directory listings. Banners will usually cause the parser to fail, and since banners are simply text files - it is impossible to add options to allow you to skip them. The 'solution' is to let DataArmour skip any lines that fail parsing. Using this option could cause you grief if a backup really does fail in this case, nothing will be reported in the log. Leaving this option blank will cause a failed line to stop the backup. If you are going to use this option, you should perform a FULL test of the ftp server by clicking on Full test.

LIST expressions

DataArmour parses each line it recives from the FTP server using the expression above. The expression tells DataArmour how the line is organised. DataArmour uses a token generator to split the line into 'tokens'. (A token is a series of characters which are usually separated by spaces, colons etc).

The First List Entry field shows how the results of a directory listing from the server are interpreted using the list expression above. The results are broken down into date, time, size and filename components.

Here is an example of a List Entry and its tokens.

-rwxr-xr-x 1 swf322 users 1499 Aug 9 19:30 filename.doc

This line would be split into the following tokens.

Token 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13
Ident | Num | Ident | Ident | Num | Ident | Num | Num | Char | Num | Ident | Char | Ident
-rwxr-xr-x | 1 | swf322 | users | 1499 | Aug | 9 | 19 | : | 30 | filename | . | doc

-rwxr-xr-x 1 swf322 users 1499 Aug 9 19:30 filename.doc

The LIST expression in detail

Attributes

Specifies that the next token will be the files attributes. If the next token is a '<', then DA will assume that a DOS style directory/size follows. Otherwise, DA will try to assemble a unix style directory specification (like the one in the example above). It is from this information that DA can tell whether or not a line from the list represents a file or a directory.

Size

Specifies that the next token in the input is the file size. This token must be numeric or an error will be generated.

Date Day/Month/Year

Specifies that the tokens following make up a date. You can specify the day/month/year operators in any order. To parse June 20 1998 you would write an expression date month day year. You can also place skip and skipsym operators in between any of the month/day/year operators.

Note re year: If the number for the year must be greater than 50 for the parser to recognise it. Also, if the
number for the year is less than 100, 1900 is added to create the final year.

Examples:

Parser sees | Year as calculated by parser
98 | 1998
105 | 105
2000 | 2000
40 | <number not used>

Time (12/24) Hour/Minute/Second [ampm]

The keyword time, followed by either 12 or 24 indicates which mode of clock to expect. 12 expects a 12hr clock (3:30am / 3:30pm) and 24 expects a 24hr clock (03:30 / 15:30). The hour/minute/second operators work the same way as they do in date - simply put them in the order in which the data appears from the FTP server. If the chosen time mode is 12, then TIME may contain the ampm operator, to indicate where the am/pm symbol is located in the input.

Any one (or all) of hour, minute or second can be left out of the expression. If any term is not included, then the current default is used. i.e: If the current date (when the parser runs) is 1 Jan 1998, 12:05:00pm, and you specify the time part of the expression as:

time 12 hour skipSym : minute

The timestamp of the file will be <file hour>:<file minute>:00. Where the 00 comes from the current date time (as mentioned above). The same happens if you leave out any of hour or minute. The missing value is simply replaced by the relevant component of the current time. A warning: Doing this obviously makes the time returned by the parser incorrect - and as such, the FTP format editor will automatically disable the time option for file comparisions.

To parse a time like: 12:30:50pm write:
time 12 hour skipSym : minute skipSym : second ampm

Filename [ForceDos]

Specifies the next token as the name of the file. If DOSNAME is specified then it interprets the name as an 8.3 filename. If DOSNAME is not specified then the filename can be any combination of characters and includes every character up to the end of the line.

Skip

Skips the next token in the input stream, regardless of what it is

SkipSym Symbol

Skips the next token in the input stream, only if the token matches the one you supply.

e.g: skipSym : would skip a colon if it exists in the input stream.

-rwxr-xr-x 1 swf322 users 1499 Aug 9 19:30 filename.doc

Using the same example as above, the commands would be

attributes skip skip skip
size
date month day year
time 24 hour skipsym : minute skipsym : second
filename

This would assign the first token to attributes, skip the next three tokens, the third is the files size, fourth and fifth tokens (perhaps even sixth) are date related, sixth, sevent and eighth is hours, minutes and seconds (of time stamp) respectively. Colons are skipped if present in between time fields/tokens. The remaining part of the line is assumed to be the filename.

How to add an FTP list expression

  • Enter the name of a format, in this case we will use NT FTP.
  • Enter the FTP command that will generate a file list from the remote FTP server. In our example we will use ‘List’ - this should be the default - you dont need to change it unless your FTP server uses a different command.
  • At this time click on the Get server directory. This will return a listing of files in the destination folder as specified in item options destination folder
  • You should now see a single line (this will be the first line returned) from the listing in the First List Entry field. If you wish to see a complete listing you may select the List Output tab.
  • Our First List Entry field looks like this:

    -rwxr-xr-x 1 swf322 users 1499 Aug 9 19:10 filename.doc

LIST Output Tab

ftplisttab.gif (10766 bytes)

The list output screen shows the complete file listing which was returned from the FTP server. The fields are fixed width and cannot be adjusted, so you may need to resize the DataArmour window to see the full screen.

You may select any item in the list above by clicking on it with the left mouse button. This will then higlight the item and place the selected line into the First List Entry field on the Format Editor Tab.

FTP Server Output

FTPServerOutput.gif (15329 bytes)

The FTP Server Output shows a complete listing of all input and output from the FTP server. This screen enables you to view all commands sent to the FTP server and all messages returned form it. This will enable you to effectively debug any problems that you may.

Results of full parse

FTPresultsoffullparse.gif (15090 bytes)

This screen shows you the results of a full parse using the list expression you have created.


Overview

Configuration

This section outlines all configuration options for DataArmour. You can access the configuration dialog either by choosing Configuration... from the Edit menu, or by clicking on the Edit configuration button on the toolbar.

Configuration is split into four ares: General, logging, directories and network. Click on the topic below to learn more.

  • General
  • Logging
  • Directories
  • Network


General configuation

General configuration

configuration.gif (7322 bytes)

Delay copy start | Specifies the number of minutes that DataArmour will wait before beginning any backup process. This gives your system time to boot up before more disk thrashing occurs!
Allow maximum of 'n' threads | Limits the number of backup items that can be running at once. If you set this to one (1), each backup item will execute sequentially. This can be usefull if you would like DataArmour to impact performance as little as possible. If you are performing many backups to FTP sites (at mediocre connection speeds) it might be usefull to bump this up to a higher value.
Application priority | Sets the priority of the DataArmour application relative to other running applications.
Start when windows starts | If ticked, DataArmour will load when you start windows. It achives this not by placing an icon in the 'Startup' folder, but by placing a key in the registry. The key location is: HKEY_CURRENT_USER \ Software \ Microsoft \ Windows \ CurrentVersion \ Run \ DataArmour.
Compact process heaps | This works for Windows NT only. If ticked, when all backups complete, the process heaps will be compacted - the aim being to reduce memory fragmentation and increase system performance.
Show on task bar when minimized | Applies only when DataArmour is minimized. If ticked, DataArmour will have its own 'button' in the task bar and an icon in the system tray. If un-ticked, only the icon in the system tray will be visible.
Show unhandled exceptions | Unfortunately, we humans are not perfect. If anything goes horribly wrong in DataArmour, you can choose to log the fault. A small, information email to the author would then be in order.
Centre windows over mouse | If enabled, all windows (item editor, FTP format editor, configuration and log) will centre over the mouse when they open. If the new position of the window would be out of screen bounds, the window will automatically be repositioned so that it is as visible as possible (taking into account the position and size of the task bar).
Encrypt registry settings | If enabled, the configuration data is encrypted before it is written to the registry. This will be required if you use the FTP features of DataArmour. When you have instructed DataArmour to backup to an FTP site, you have to supply a username and password. For these details to be stored without encrytion, it would be possible for someone to view the registry and obtain the username and password for the FTP server. By encryting these settings, you minimise this possibility.
Minimize when closed pressed | When enabled this will cause DataArmour to be minimized when the close application by clicking on the close button icon in the upper right corner of the DataArmour window. If this option is not selected then DataArmour will exit and will be unable to perform any backup items.
Autorefresh log | If ticked, forces DataArmour to update the log file window (it must be open) when the current running backup(s) complete. This saves you having to click the Refresh button in the log window.
Require write access during backup | With this option enabled, DataArmour will perform a check to ensure that it has full, exclusive write access to files before they are backed up. This will prevent DataArmour from backing up any files that have been opened for write access by other applications or the operating system. This option is used in conjunction with open file options in the options tab of a backup item properties.
Truncate log | Ensures that the log file does not exceed the specified size. The log file is checked (and possibly truncated) and the end of a backup (when all items have completed).
Log management of Handles | Used only for testing: Logs the management of handles used to track the on file change rules.
Log management of Threads | Used only for testing: Logs the management of threads. Threads are created/destroyed for each backup item.
Seperate config per user | If enabled, the configuration files for DataArmour are saved under the users registry key. If disabled, DataArmours settings are saved under the machines registry key; thus anyone who logs onto the machine will share the same DataArmour settings.


Directory configuration

Directories

configuration directories.gif (6535 bytes)

When DataArmour first starts, it will set some default values based on the installation directory and the current registry settings (it will use the currently registered .zip viewer, and current temporary directory)

In each case, if the current settings are incorrect, use the relevant Find/Browse button to change them.

Log file | Specifies the path and filename for the log file.
Temp directory | Temporary directory used when creating or modifying ZIP files.
ZIP Viewing utility | Program that you would like to use to view ZIP files. DataArmour uses this setting when you choose to view the contents of an item that is configured as ZIP Copy.
DataArmour settings - backup file | The path and filename of the DataArmour settings backup file. This can be placed anywhere, and it is recommended that you include it on one of your rules. These backup files can be re-imported into DataArmour using the Restore settings from file option on the Edit menu.


Logging options

Logging

configuration logging.gif (5106 bytes)

Truncate log | Ensures that the log file does not exceed the specified size. The log file is checked (and possibly truncated) and the end of a backup (when all items have completed).
Handle activity | Used only for testing: Logs the management of handles used to track the on file change rules.
Thread activity | Used only for testing: Logs the management of threads. Threads are created/destroyed for each backup item.


Internet configuration

configuration.gif (7322 bytes)

Email address | Not yet implemented
Network Directory Settings | The temporary directory location for any temporary files created during the FTP process.


Network configuration

configuration network.gif (4712 bytes)

Perform speed check before commencing backup | DataArmour will check the available bandwidth of the destination drive before commencing the backup. This will be usefull when you perform a backup to a FTP site or remote drive and do not wish to use a slow conenction (eg: A notebook conencted to a LAN as well as a cellular network). The speed check can be performed on local, as well as network drives.
Scan Scope scanscopebutton.gif (1111 bytes) | Scan scope only effects the network node of the tree. You may specify whether DataArmour scans Globally for mapped networked drives and available network shares. Ie: the same list that you see when browsing the Network neighbourhood; Connected network drives; Remembered will scan only network mappings that are reconnected at logon. Mapped drives that are created through the course of a session, but are not re-established after the user has logged off, will not be scanned. By default the Scan scope is Global
Refresh <option> | The refresh button will perform a re-scan of the network devices, dependant on the scan scope that you have specified.
Add User defined name | Adding a user defined name can be used if the network scan option does not return all valid network names (This could be the case if you have non supported network). Eg; It might not pick up a certain share name. If it doesn't, you can enter it by hand. It will appear under the User defined node.. To remove a user defined name, edit its name and make it blank, press enter and you will then be prompted to delete it.
Available devices | Local disks - shows all physical drives on the local system Network / shares - shows all mapped network drives, and if a Global scan is performed, will also show all available network shares. User defined / FTP - shows all FTP sites that are currently in use as a destination for any backup item and any user defined names.
Allow transfer if rate excees xxx | Specify the bandwidth that must be available for the backup to be performed. The unit of measure is definable below as either Bytes, Kilobytes and Megabytes. The speed test must exceed this figure for the backup to commence.
Test for x seconds | The longer the test, the more accurate the measure of a drives transfer speed. Default and recommended time is 5 seconds.


Log file overview

Overview of the log file

DataArmour writes all of its status and other relevant information to a log file. This log file is normally stored in the same directory that you installed the applicaton.

Click here to get detailed information on

  • Whats in the log file
  • Viewing the log as a text document
  • Clearing the log
  • Refreshing the log


Log file details

Log entry types

The log file can be access by selecting the Latest activity... option from the View menu, or by clicking on the Show activity log button on the toolbar. The log window looks like this (yours may vary):

>

The log is heirarchical, with entries for each backup item that has run at the base of the heirarchy. Each entry in the log records the activity that happened at the time the item was run. There are several main sections to each items log entry.

  1. General item details
  2. List of files that were scanned from the source locations
  3. List of files backed up by DataArmour
  4. List of deleted files
  5. Errors

You can easily spot problems in the log due to the icons at the left of the log entries.

Warning: Something failed.
The log will contain additional information regarding the cause of the error. A typical error would be the failure to cop y a file (either when performing a ZIP backup or a Direct copy) due to lack or priveledges.
Exclamation: Something unexpected occurred. This may or may not be fatal.
Additional information will be in the log. Example: A file could not be copied becuase it was open.
Information: Indicates a general, informative statement
Question: Indicates that this item has not yet been completed and is still running.
Its final state is unknown
Used when a file name or path is being reported on.
Specifies that the backup completed successfully.

You can close the log viewer either by clicking on the close button, or by using the X at the top right hand corner. The Logfile buttons are described here.

Note: If you have a large log file, the it may take a few seconds for the log viewer to appear (this is because its takes a few moments for the log viewer to populate itself from the log file)


Logfile buttons

Log file details

Log file buttons and descriptions

Close | Closes the log window
Refresh | Clears the contents of the log window (not the log!) and refreshes the log from the internal-memory log
View as text | Converts the log to text and shows it using notepad
Clear log | Clears the internal-memory log, clears the disk log. This cannot be undone.


Registration overview

Registration

Registration of DataArmour can be done online, or via normal mail.

Please click on the subect you would like more information about

  • How to register DataArmour


How to register DataArmour

How to Registering DataArmour

Registration provides for continued development of DataArmour, it also gives you, the user:

  • Access to free support via email.
  • Discount on upgrades.
  • Latest information on the future releases.
  • Ability to participate in beta-test's of upcoming releases.

There are a number of ways that you can register DataArmour. Normally, you should choose the Pricing option from the Registration submenu (this is on the Help menu). This will load your web browser, and show you the relevant pricing details for DataArmour. You can then register online.

Note: The above process assumes you are connected to the internet.

Once registered, you will be emailed a registration code. The details as supplied in the email must be entered exactly as shown, into the Register screen.

RegisterWindow.gif (3852 bytes)

Enter the details (or copy/paste them from the email) into the fields and press OK. If the registration code is correct, a small message box will appear, thanking you for your registration.

The registration details are case sensitive. Thus the name "neil clayton" is not the same as "Neil Clayton".

If you do not want to order via credit card online

You can order DataArmour by filling out the supplied order form (see the file, order.txt, in the installation directory of DataArmour).

Note: Please do not send credit card details. If you intend to purchase via credit card, you must place the order yourself - either online or by calling the numbers as detailed on the ordering web page.

Bulk purchase discounts are available, send all enquiries to nclayton@ihug.co.nz for more information.


Command line options

-check | Check to see if any items require execution. If so, then execute those items and automatically quit when those items have completed. Note: Any items with their on file change option set will not be included in this check. DataArmour must be running for the monitoring process to work.
-force | Force all items to execute, regardless of their next execution times.

example:

d:\program files\TCDC\DataArmour -force -check


About

About the author

written by Neil Clayton, Copyright 1998.

The author can be contacted by email nclayton@ihug.co.nz or via normal mail at:

8a Steyne Ave
Plimmerton
Wellington
New Zealand

The homepage address for DataArmour is: http://homepages.ihug.co.nz/~nclayton


The backup process

Title

Headings should be like this

This is a topic file. Text should go here. Any interesting items should be highlighted


File Menus

File Menu

Preview Items Now
This will perform a pseudo backup of the item selected. It will log all details to the log file and enable you test you backup items before they are run in real time. You can view what files are to be backup up from the log file. You may also use toolbar preview.gif (914 bytes) icon from the toolbar.

Run Items Now
This will force DataArmour to execute the currently highlighted backup item(s). This achieves the same function as the run image.gif (964 bytes) icon on the toolbar. You may select the run function from a backup items context menu. This is available by right clicking a backup item and then selecting run.

Stop Items
This will attempt to stop the selected running thread. The stopping of a thread is not instantaneous and may cause data corruption. DataArmour will prompt you to confirm your decision to stop an active thread. You may select the stop function from a backup items context menu. This is available by right clicking a backup item and then selecting stop. backup in progress.gif (18965 bytes)

This option wil not be available if the backup item is not currently running.

This is the warning you will receive when attempting to stop a currently running backup item. Use caution when stopping backup items!

Exit
Will close DataArmour. If there are threads currently running, DataArmour will attempt to stop them before exiting The close window icon window close.gif (907 bytes) does not cause DataArmour to exit, but minimises it to the system tray. Once again, exiting DataArmour while backup items are running may cause data loss.

Edit

Insert Item
This will create a new backup item. This may also be achieved by pressing the new backup item.gif (892 bytes) icon on the toolbar.

Edit Item
This option enables you to edit the currently selected or highlighted backup item. This may also be achieved by pressing the toolbar edit.gif (938 bytes) icon on the tool bar.

Delete Item
This option will delete the currently selected backup item. This may also be achieved by pressing the toolbar delete.gif (887 bytes) icon on the toolbar.

DataArmour Priority
You may select the priority of the DataArmour process. This sets the priority of the process relative to other running processes. If this is set to 'Low', then other processes will have priority over DataArmour. This is intended to keep DataArmours impact (while performing backups) on the operating system minimal.

Check all rules
This will force DataArmour to check the validity of all rules for all backup items. This is usefull when you want to ensure that all rules are valid without having to physically edit each rule. Just select this option, and any problems will be highlighted. (This function may need to be performed after any upgrade to DataArmour to ascertain if your existing rules are still valid. )

Configuration
This option, also available with the Ctrl-F2 hotkey will display the current DataArmour configuration.

Restore settings from file
DataArmour writes a copy of all registry settings and entries to a disk file. In the event that you have to re-install DataArmour, you may use this function to restore all of your previous settings to the registry. DataArmour stores all backup item and configuration settings in the file. The name of the file used to store the settings is configurable.

View

Item Contents
This function will show you the contents of the currently selected backup item. If the backup item destination is to a zip file, then DataArmour will view the zip file with the configured zip file viewer. If the backup item is a direct copy, then it will open a browsing window and display the destination directory and files.

Latest Activity
This will view the logfile that is generated by DataArmour during the backup process. This may also be achieved by pressing the toolbar veiw activity.gif (935 bytes) icon on the toolbar.


Directory Tree Options

Entire Structure This option ensures that DataArmour copies the entire source files directory structure to the destination folder. This is best demonstrated in an example:

Your source directory is: "c:\my documents\letters" and you have a rule which backs up all files with a ".DOC" extension. You specify that the Entire structure is to backed up by DataArmour with the destination folder as "A:\backup". As the example there are two files called resume.doc and readme.doc.

explorer example full structure.gif (25111 bytes)

DataArmour will copy all ".DOC" files from the source folder and replicate the entire structure of the source folder into the destination folder. As a result the destination will look like this:
"A:\backup\my documents\letters\resume.doc"
"A:\backup\my documents\letters\readme.doc"

Some structure, grouped by drive/unc This option causes DataArmour to reduce the source directory structure down to the lowest common path for all rules. Once again, this is best demonstrated by an example of a backup item with a single rule.

Example 1:
Your source directory is "c:\my documents\letters" and you have a rule which backs up all files with the ".DOC" extension. You specify that Some structure, grouped by drive/unc is to be backed up DataArmour with the destination folder as "A:\backup".

DataArmour will examine the full path of the files being backed up, in this case "c:\my documents\letters".

explorer example unc example 1.gif (22090 bytes)

DataArmour examines every source file and path and removes what is called the "common prefix" of the path. Eg: Each file looks like this:
"c:\my documents\letters\resume.doc"
"c:\my documents\letters\readme.doc"

DataArmour looks to remove as much of the path as possible to ensure that the destination file and path remain unique. In this case, DataArmour would remove "c:\my documents\letters\" and as a result the files would be stored in the root of the destination directory.

This is a simple example, with only one rule. A more complicated example is given below, illustrating a single rule, with subdirectories.

Example 2:
Using the same details above, we will now assume that the "c:\my documents\letters\" directory has two sub-directories, "Projects" and "Business". Within the "Business" directory is a file called "Resume.doc" and in the "Projects" directory are files called "Helpme.doc" and "Readme.doc"

When DataArmour starts the backup, the files will look like this:
"c:\my documents\letters\resume.doc"
"c:\my documents\letters\readme.doc"
"c:\my documents\letters\projects\readme.doc"
"c:\my documents\letters\projects\helpme.doc"
"c:\my documents\letters\business\resume.doc"

explorer example unc example 2.gif (24641 bytes)

DataArmour examines the files and determines that the common prefix is "c:\my documents\letters\". It will now copy files to the destination, which will look like this:
"a:\backup\resume.doc"
"a:\backup\readme.doc"
"a:\backup\projects\readme.doc"
"a:\backup\projects\helpme.doc"
"a:\backup\business\resume.doc"

Example 3:
Once again using the same details, we will be backing up from three seperate drives and directory structures.
We are backing up "c:\my documents\", "d:\Office\templates\" and "e:\system\drivers\". To keep it simple, we are backing up all files in each of these directories and including all sub-directories.

explorer example unc example 3.gif (32636 bytes)

When DataArmour starts the backup, the files look like this:
"c:\my documents\letters\resume.doc"
"c:\my documents\letters\readme.doc"
"d:\office\templates\normal.dot"
"e:\system\drivers\stealth3d.dll"
"e:\system\drivers\mydriver.dll"

As you can see the destinatyion directory structure is not touched in any way, but DataArmour has added the source drive as a primary directory. This is to prevent two directories named the same, from different drives coming into conflict. For example:
"c:\my documents\" and "d:\my documents".